  typedef enum {
      NEG,
      POS
  } sinal;

  typedef struct {
      sinal sin;
      unsigned int num;
      unsigned int den;
  } racional;

  typedef struct {
      union {
          int i;
          racional r;
      } val;
      enum {
          INT,
          RAC
      } tip;
  } numero;

int compare(numero n1, numero n2)
{
     int m, n;
     if (n1.tip == INT) {
          if (n2.tip == INT) {
               n = n1.val.i;
               m = n2.val.i;
          }
          else {
               n = n2.val.r.den * n1.val.i;
               m = n2.val.r.num;
               if (n2.val.r.sin == NEG) m *= -1;
          }
     }
     else {
          if (n2.tip == INT) {
               m = n2.val.i * n1.val.r.den;
               n = n1.val.r.num;
               if (n1.val.r.sin == NEG) n *= -1;
          }
          else {
               m = n2.val.r.num * n1.val.r.den;
               if (n2.val.r.sin == NEG) m *= -1;
               n = n2.val.r.den * n1.val.r.num;
               if (n1.val.r.sin == NEG) n *= -1;
          }
     }
     return n == m ? 0 : (n > m ? 1 : -1);
}


/* int gcd(int n1, int n2)
 * {
 *      if (n1 == n2) return n1;
 *      if (n1 < n2) return gcd(n2, n1);
 *      return gcd(n1 % n2, n2);
 * }
 *
 * int add(numero *n1, numero n2)
 * {
 *      if (n1->tipo == INTEIRO) {
 *           if (n2.tipo == INTEIRO) {
 *                n1->value.inteiro += n2.value.inteiro;
 *           }
 *           else {
 *                numero n;
 *                n = *n1;
 *                *n1 = n2;
 *                n2 = n;
 *           }
 *      }
 *      if (n1->tipo == RACIONAL) {
 *           if (n2.tipo == INTEIRO) {
 *                int g;
 *                int den = n1->value.racional.denominador;
 *                int num = n1->value.racional.numerador;
 *                if (n1->value.racional.sinal == NEGATIVO) num *= -1;
 *                num += den * n2.value.inteiro;
 *                g = gcd(num, den);
 *                num /= g;
 *                den /= g;
 *                if (num == 0 || den == 1) {
 *                     n1->tipo = INTEIRO;
 *                     n1->value.inteiro = num;
 *                }
 *                else {
 *                     n1->value.racional.denominador = den;
 *                     if (num > 0) {
 *                          n1->value.racional.sinal == POSITIVO;
 *                          n1->value.racional.numerador = num;
 *                     }
 *                     else {
 *                          n1->value.racional.sinal == NEGATIVO;
 *                          n1->value.racional.numerador = -num;
 *                     }
 *                }
 *           }
 *           else {
 *                int num, g;
 *                int den = n1->value.racional.denominador * n2.value.racional.denominador;
 *                int num1 = n1->value.racional.numerador * n2.value.racional.denominador;
 *                int num2 = n1->value.racional.denominador * n2.value.racional.numerador;
 *                if (n1->value.racional.sinal == NEGATIVO) num1 *= -1;
 *                if (n2.value.racional.sinal == NEGATIVO) num2 *= -1;
 *                num = num1 + num2;
 *                g = gcd(num, den);
 *                num /= g;
 *                den /= g;
 *                if (num == 0 || den == 1) {
 *                     n1->tipo = INTEIRO;
 *                     n1->value.inteiro = num;
 *                }
 *                else {
 *                     n1->value.racional.denominador = den;
 *                     if (num > 0) {
 *                          n1->value.racional.sinal == POSITIVO;
 *                          n1->value.racional.numerador = num;
 *                     }
 *                     else {
 *                          n1->value.racional.sinal == NEGATIVO;
 *                          n1->value.racional.numerador = -num;
 *                     }
 *                }
 *
 *           }
 *
 * } */

int main(void){}
